#include <stdlib.h>
#include <stdio.h>
#include <datamon.h>
 
#define check(x) if((x)) {fprintf(stderr, "%s\n", dm_get_error_string());exit(1);}
 
main(int argc, char * argv[])
{
   program_descriptor_t pgm;
   object_descriptor_t   obj;
   char buffer[100];
 
   if (argc != 2) {
      fprintf (stderr, "Usage: set_workload integer-value\n");
      exit(1);
   }
 
   check(dm_open_program("wave",0,&pgm));
   check(dm_get_descriptor("workload",0,pgm,&obj));
   check(dm_get_value(&obj,buffer,sizeof(buffer)));
   check(dm_set_value(&obj,argv[1]));
 
   printf ("workload: old_value=%s, new_value=%s\n", buffer, argv[1]);
}

