#include <stdio.h>
#include <sched.h>
#include <errno.h>
#include <cpuset.h>
#include <string.h>
#include <stdlib.h>

main()
{
	cpuset_t *mask;
	int ret,cpu;
	unsigned int cpusetsize;
	extern int errno;
	char *txt;

	cpusetsize = cpuset_allocsize();
	mask = (cpuset_t*)cpuset_alloc();
	ret = sched_getaffinity(getpid(),cpusetsize,mask);
	if (ret!=(-1))
	{
		txt = cpuset_get_string(mask);
		printf("sched_getaffinity is %s\n",txt);
		free(txt);
	}
	else
	{
		printf("sched_getaffinity is error %s\n",strerror(errno));
	}

	
        for(cpu=cpuset_min_cpu();cpu<cpuset_max_cpu() ;cpu++)
        {
		cpuset_init(mask);
		cpuset_set_cpu(mask,cpu,1);
		ret = sched_setaffinity(getpid(),cpusetsize,mask);
		if (ret==0)
		{
			txt = cpuset_get_string(mask);
			printf("sched_setaffinity is %s\n",txt);
			free(txt);
		}
		else
		{
			printf("sched_setaffinity is error %s\n",strerror(errno));
		}
        }
	cpuset_free(mask);
}
