#include <stdio.h>
#include <sched.h>
#include <time.h>
#include <sys/types.h>

/*
[root@RehHawk5 sched]# ./sched 
SCHED_FIFO priority min is 1
SCHED_FIFO priority max is 99
SCHED_RR priority min is 1
SCHED_RR priority max is 99
SCHED_RR interval is 0.100006250
*/


main()
{
        static struct sched_param myparam;
	int min,max;
	struct timespec rr;


	min = sched_get_priority_min(SCHED_FIFO);
	max = sched_get_priority_max(SCHED_FIFO);
	printf("SCHED_FIFO priority min is %d\n",min);
	printf("SCHED_FIFO priority max is %d\n",max);
	
	min = sched_get_priority_min(SCHED_RR);
	max = sched_get_priority_max(SCHED_RR);
        myparam.sched_priority = min;
        sched_setscheduler(getpid(),SCHED_RR,&myparam);
	sched_rr_get_interval(getpid(),&rr);
	printf("SCHED_RR priority min is %d\n",min);
	printf("SCHED_RR priority max is %d\n",max);
	printf("SCHED_RR interval is %d.%d\n",rr.tv_sec,rr.tv_nsec);

}

